"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const sequelize_typescript_1 = require("sequelize-typescript");
const model_1 = require("../model");
let Asset = class Asset extends sequelize_typescript_1.Model {
    get created_at() {
        return this.getDataValue('created_at');
    }
    get updated_at() {
        return this.getDataValue('updated_at');
    }
    get deleted_at() {
        return this.getDataValue('deleted_at');
    }
};
__decorate([
    sequelize_typescript_1.Column({
        primaryKey: true,
        type: sequelize_typescript_1.DataType.STRING(10),
        comment: '资产名'
    }),
    __metadata("design:type", String)
], Asset.prototype, "asset", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => model_1.Account),
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Asset.prototype, "account_id", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => model_1.Account),
    __metadata("design:type", model_1.Account)
], Asset.prototype, "account", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.STRING(10),
        comment: '商品类型'
    }),
    __metadata("design:type", String)
], Asset.prototype, "type", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.INTEGER(10),
        comment: '小数点精度'
    }),
    __metadata("design:type", Number)
], Asset.prototype, "amount_precision", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.STRING(20),
        comment: '保有量'
    }),
    __metadata("design:type", String)
], Asset.prototype, "onhand_amount", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.STRING(20),
        comment: '锁定量'
    }),
    __metadata("design:type", String)
], Asset.prototype, "locked_amount", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.STRING(20),
        comment: '可使用量'
    }),
    __metadata("design:type", String)
], Asset.prototype, "free_amount", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.CHAR(1),
        comment: '回测模式'
    }),
    __metadata("design:type", String)
], Asset.prototype, "backtest", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String),
    __metadata("design:paramtypes", [])
], Asset.prototype, "created_at", null);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String),
    __metadata("design:paramtypes", [])
], Asset.prototype, "updated_at", null);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String),
    __metadata("design:paramtypes", [])
], Asset.prototype, "deleted_at", null);
Asset = __decorate([
    sequelize_typescript_1.Table({
        timestamps: true,
        paranoid: true,
        underscored: true,
        tableName: 'asset',
        comment: '资产'
    })
], Asset);
exports.default = Asset;
